Const graphics_width = 1024, graphics_height = 768

Graphics graphics_width, graphics_height
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Dim cell(48, 48)	;MAP SQUARES
Global cell_on
Dim map_names$(100)

Global state									
Global phase, turn								;PHASE = PLAYER GO, TURN = GAME TURN NUMBER
Global x_cell, y_cell							;FOR SELECTED TILE
Global old_time									
Global cursor_pic = 15, unit_held
Global action_state
Global attackstart, attack_x_pos, attack_y_pos, attack_rad, attack_range
Global attack_box_col, attack_box_s 
Global display_health


Dim player_units(2,10) 							;player, unit handle
Dim player_cash(2), player_num_units(2)
Global num_maps, map_selection
player_cash(1) = 500: player_cash(2) = 500

Global u.unit
Type unit
Field cost, name$		;COST TO BUY AND UNIT NAME 
Field ex, level			;EXPERIENCE AND LEVEL
Field x, y, frame,frames;LOCATION AND IMAGE FRAME
Field hp, mp, ap 		;HEALTH, MAGIC, ACTION POINTS
Field dam_min, dam_max	;DAMAGE RANGE 
Field s1, s2, s3		;SPECIAL ABILITIES
Field move, attacks
End Type
Dim unit_han(1000)

Type new_man
Field cost, name$		;COST TO BUY AND UNIT NAME 
Field frame,frames 		;IMAGE FRAME + NUMBER OF FRAMES
Field hp, mp, ap		;HEALTH, MAGIC, ACTION POINTS
Field dam_min, dam_max	;DAMAGE RANGE 
Field range				;RANGE OF ATTACK
Field move, attacks
Field s1, s2, s3		;SPECIAL ABILITIES
End Type
Dim constructor_han(25)

Type effects
Field x, y, id, frame, timer
End Type

Type point
Field x, y, number, nogo
End Type

Dim ter_name$(20), ter_move(20), ter_def(20), ter_los(20);TERRAIN TYPES
Global ter_han


Global font1 = LoadFont("Arial", 14, 0, 0, 0) 
Global font2 = LoadFont("Arial", 14, 1, 0, 0) 
Global font3 = LoadFont("Arial", 16, 0, 0, 0)
Global font4 = LoadFont("Onyx", 35, 1, 0, 0)
Global font5 = LoadFont("Onyx", 72, 1, 0, 0)

Global tiles = LoadAnimImage("Graphics\Tiles.bmp", 16, 16, 0, 128)
Global icons = LoadAnimImage("Graphics\Icons.bmp", 16, 16, 0, 16)
Global units = LoadAnimImage("Graphics\Units.PNG", 16, 16, 0, 96)
Global buttons = LoadAnimImage("Graphics\Big Buttons.PNG", 32, 32, 0, 4)
Global effects = LoadAnimImage("Graphics\Effects.PNG", 16, 16, 0, 10)
Global minimap
MaskImage icons, 255, 0, 255:	MaskImage units, 255, 0, 255:	
MaskImage buttons, 255, 0, 255:	MaskImage effects, 255, 0, 255:
Global map_image = CreateImage(1024, 768)

Global miname$

UNIT_CONSTRUCTOR()
TERRAIN_TYPES()
;----------------------------------------------------------------------------------------------------;
;---------------------------- CHECK WHAT MAPS ARE AVAILABLE -----------------------------------------;
;----------------------------------------------------------------------------------------------------;
map_dir$ = CurrentDir$()
map_dir$ = map_dir$ +"\Maps"
readmaps = ReadDir(map_dir$)
For i = 1 To 100 
	map_names$(i) = NextFile$(readmaps)
	If map_names$(i) = "" 
		num_maps  = i
		Exit 
	EndIf 
Next
CloseDir readmaps 
;----------------------------------------------------------------------------------------------------;
;****************************************** MAIN LOOP ***********************************************;
;----------------------------------------------------------------------------------------------------;
state =1

While Not KeyHit(1)

	Cls
	If state = 0			;TITLE
			
	Else If state = 1		;PICKMEN
		GAME_SETUP()		
	Else If state = 2		;PLACE UNITS
		PLACE_UNITS()
	Else If state = 3		;MAIN GAME
		DrawImage map_image, 0,0
		HILIGHTER()
		DRAW_UNITS()
		EFFECTS()
		SIDEBAR()
		UNIT_ACTIONS()
		MOUSE_INPUT()
		KEY_INPUT()
		CELL_NUMBERS() 
		If KeyHit(57) Then END_PHASE()
	Else					;END 

	EndIf
	Rect MouseX(), MouseY(), 1, 1
	DrawImage icons, MouseX(), MouseY(), cursor_pic
	Flip
Wend

;----------------------------------------------------------------------------------------------------;
;****************************************************************************************************;
;----------------------------------------------------------------------------------------------------;
Function ANIMATE_UNITS()

If MilliSecs() >= (old_time+500) ;every half second  
	For u.unit = Each unit
		For n.new_man = Each new_man
			If n\name$ = u\name$ Then Exit
		Next
		u\frame = u\frame + 1
		If u\frame >= n\frame+u\frames
			u\frame = n\frame 
		EndIf  
	Next 
	old_time = MilliSecs()
EndIf

End Function
;----------------------------------------------------------------------------------------------------;
;****************************************************************************************************;
;----------------------------------------------------------------------------------------------------;
Function TERRAIN_TYPES()

ter_name(1) = "Grass":			ter_move(1) = 2:						ter_los(1)=0
ter_name(2) = "Field":			ter_move(2) = 2:						ter_los(2)=0					
ter_name(3) = "Swamp":			ter_move(3) = 4:	ter_def(3)=1:		ter_los(3)=0
ter_name(4) = "Lake":			ter_move(4) = 100:						ter_los(4)=0
ter_name(5) = "Sea":			ter_move(5) = 100:						ter_los(1)=0
ter_name(6) = "River":			ter_move(6) = 3:						ter_los(1)=0
ter_name(7) = "Road":			ter_move(7) = 1:						ter_los(1)=0
ter_name(8) = "Dense Forest":	ter_move(8) = 3:	ter_def(8)=2:		ter_los(1)=1
ter_name(9) = "Forest Edge":	ter_move(9) = 2:	ter_def(9)=1:		ter_los(1)=1
ter_name(10)= "Light Woods":	ter_move(10)= 2:	ter_def(10)=1:		ter_los(1)=0
ter_name(11)= "Hill":			ter_move(11)= 3:	ter_def(11)=2:		ter_los(1)=2

End Function 
;----------------------------------------------------------------------------------------------------;
;****************************************************************************************************;
;----------------------------------------------------------------------------------------------------;
Function GAME_SETUP()

;SET CASH-----------------------------;
Color 40, 40, 40:		Rect 260, 20, 140, 40, 1
Color 80, 80, 80:		Rect 260, 20, 140, 40, 0
Color 20, 20, 20:		Rect 320, 24, 40, 14, 1

SetFont font2:	Color 100, 100, 100	
Text 264,24, "CASH: " 
If phase = 0 Then  Text 324, 24, player_cash(1)
;CHOOSE  A MAP------------------------;

Color 40, 40, 40:		Rect 100, 20, 140, 140, 1
Color 80, 80, 80:		Rect 100, 20, 140, 140, 0
Color 20, 20, 20:		Rect 110, 30, 120, 120, 1

If minimap <> 0 Then DrawImage minimap, 123, 43

Color 40, 40, 40:		Rect 100, 180, 140, 140, 1
Color 80, 80, 80:		Rect 100, 180, 140, 140, 0
Color 20, 20, 20:		Rect 110, 200, 120, (num_maps-1)*14, 1
Color 100, 100, 100:	Text 110, 184, "SELECT A MAP"

Color 100, 00, 0
For i = 1 To num_maps
	Text 112, 186+(i*14), map_names(i)
Next

;BUY UNITS----------------------------;
If phase = 1 Or phase = 2
	If phase = 2 Then bit = 10
	Color 40, 40, 40:		Rect 512, 20, 190, 262, 1
	Color 80, 80, 80:		Rect 512, 20, 190, 262, 0	
	SetFont font4:			Text 520, 24, "PLAYER " +phase +" BUY UNITS"
	SetFont font2:			Text 526, 262, "CASH REMAINING: "
	Color 20, 20, 20		Rect 642, 262, 52, 14, 1
	Color 100, 0, 0:		Text 646, 262, player_cash(phase)
	n.new_man = First new_man
	For i = 1 To 10
		n = Object new_man constructor_han(i+bit)
		
		Color 80, 80, 80:	 Text 536, 41+(i*20), n\name$ +" cost: " +n\cost  
		Color 20, 20, 20:	 Rect 658, 41+(i*20), 20, 14, 1
		Color 100, 0, 0	:	 Text 662, 41+(i*20), player_units(phase, constructor_han(i)) 
		
		If player_units(phase, constructor_han(i)) > 0;if player has one or more of unit type
			DrawImage icons, 640, 40+(i*20), 10		;minus button on
		Else										;else
			DrawImage icons, 640, 40+(i*20), 12		;minus button off
		EndIf 
		
		If player_cash(phase) >= n\cost					;if player can afford another unit 
			DrawImage icons, 680, 40+(i*20), 11		;plus button active
		Else 										;else
			DrawImage icons, 680, 40+(i*20), 13		;plus button inactive
		EndIf 
		
		DrawImage units, 516, 40+(i*20), n\frame
	Next
;MOVE INTO GAME----------------------------;
Else If phase = 3
		LOAD_MAP(map_names$(map_selection))
		INITIATE_GAME()
		state = 2	
		phase = 1
EndIf

;INPUT--------------------------------;
If MouseHit(1)
	If phase = 0
		;SELECT A MAP
		If MouseX() > 110 And MouseX() < 230 And MouseY() > 200 And MouseY() < 200 +(num_maps-1)*14
			map_selection = ((MouseY() - 200) / 14)+1
			selected_map$ = map_names$(map_selection)
			If selected_map$ <> "." And selected_map$ <> ".." And selected_map$ <> "thumbs.db"
				miname$ = map_names$(map_selection) 
				miname$ = Replace(miname$, "dat", "bmp")
				minimap = LoadImage("Graphics\Minimaps\"+miname$)
			EndIf 
		;ALTER CASH
		Else If MouseX() > 320 And MouseX() < 360 And MouseY() > 24 And MouseY() <38
			Color 20, 20, 20:		Rect 320, 24, 40, 14, 1		 
			Flip 
			Color 100,0,0:			Locate 324, 24
			player_cash(1) = Input()
			player_cash(2) = player_cash(1)
		EndIf 
	Else If phase = 1 Or phase = 2
		For i = 1 To 10
			n = Object new_man constructor_han(i+bit)
			;REMOVE UNIT
			If ImageRectCollide(icons, 640, 40+(i*20), 10, MouseX(), MouseY(), 1, 1) And player_units(phase, constructor_han(i)) > 0 
				player_units(phase, constructor_han(i)) = player_units(phase, constructor_han(i)) -1
				player_cash(phase) = player_cash(phase) + n\cost
				player_num_units(phase) = player_num_units(phase) -1
			;ADD UNIT
			Else If ImageRectCollide(icons, 680, 40+(i*20), 11, MouseX(), MouseY(), 1, 1) And player_cash(phase) >= n\cost
				player_units(phase, constructor_han(i)) = player_units(phase, constructor_han(i)) +1
				player_cash(phase) = player_cash(phase) - n\cost
				player_num_units(phase) = player_num_units(phase) +1				
			EndIf 
		Next   
	EndIf 
Else If MouseHit(2)
	phase = phase +1 	
EndIf 		
End Function
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function LOAD_MAP(selected_map$)
;LOAD THE SELECTED MAP-----------------------------;
readmap = OpenFile("Maps\"+selected_map$) 
For i = 1 To 11

	o = ReadLine(readmap)
Next
For y = 1 To 48
	For x = 1 To 48
		cell(y, x) = ReadInt(readmap)
	Next
Next
CloseFile(readmap)

;CREATE MAP IMAGE WITH SIDEBAR---------------------;
SetBuffer ImageBuffer(map_image) 
For y = 0 To 47 
	For x = 0 To 47 
		DrawImage tiles, x*16, y*16, cell(y+1, x+1) 
	Next
Next

Color 40, 40, 40:		Rect 768, 0, 256, 768, 1
For i = 0 To 2
	Color 80, 80, 80:		Rect 768+i, 0+i, 256-(i*2), 768-(i*2), 0	
Next
Color 20, 20, 20: Line 771, 3, 771, 764: Line 771, 3, 1020, 3
SetBuffer BackBuffer()

End Function
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function INITIATE_GAME()
;FOR EACH PLAYER
n.new_man = First new_man
For players = 1 To 2
	;FOR EACH UNIT TYPE
	For a = 1 To 10
		n = Object new_man constructor_han(a+((players-1)*10)) 
		;FOR EACH UNIT OF THIS TYPE
		For b = 1 To player_units(players, a)	
			u.unit = New unit
			u\x = 788+(a*20):	u\y=20+(b*20)
			u\cost = n\cost
			u\name$ = n\name$
			u\move = n\move
			u\frame = n\frame + Rand(0, (n\frames-1)) ;give random start frame
			u\frames = n\frames
			u\hp = n\hp:	u\mp = n\mp:	u\ap = n\ap
			u\attacks = n\attacks
			u\dam_min = n\dam_min:	u\dam_max = n\dam_max
			i=i+1
			unit_han(i) = Handle(u) 
		Next
	Next
Next
End Function
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function PLACE_UNITS()
ANIMATE_UNITS()
;DRAW BOUNDARIES------------------;
Color 150, 40, 40
If phase = 1 Then y_pos = 576
Viewport 0, y_pos, 1024, 192
DrawImage map_image, 0,0 

Viewport 0, 0, 1024, 768
Color 100, 0, 0:	Line 0, y_pos, 1024, y_pos
;---------------------------------;
Color 40, 40, 40:		Rect 768, 0, 256, 768, 1
For i = 0 To 2
	Color 80, 80, 80:		Rect 768+i, 0+i, 256-(i*2), 768-(i*2), 0	
Next
Color 20, 20, 20: Line 771, 3, 771, 764: Line 771, 3, 1020, 3

Color 100, 100, 100:										SetFont font5 
Text 140, 300, "PLAYER " +phase +" PLACE YOUR UNITS":	SetFont font2

bit = (phase-1)*player_num_units(1)
Text 10,400, bit  

u.unit = First unit
If phase =2 Then u = Object unit unit_han(player_num_units(1)+1)
DrawImage units, u\x, u\y, u\frame
For i = 2+bit To player_num_units(phase)+bit
	u = After u
	DrawImage units, u\x, u\y, u\frame
Next

;IF HOLDING UNIT ADJUST LOCATION--;
If cursor_pic = 14 
	u.unit = First unit
	u = Object unit unit_han(unit_held)
	u\x = MouseX()+10:	u\y = MouseY()+10
EndIf

;INPUT----------------------------;
If MouseHit(1)
	u2.unit = First unit
	For i = 1+bit To player_num_units(phase)+bit	;check if mouse over a unit 
		If i = 1+bit 
			u.unit = First unit
			If phase =2 Then u = Object unit unit_han(player_num_units(1)+1)
		Else
			u = After u
		EndIf 
				
		If ImageRectCollide(units, u\x, u\y, 0, MouseX(), MouseY(),1, 1) 
			;NOT HOLDING A UNIT, then pick up unit
			If cursor_pic = 15
				cursor_pic = 14
				unit_held = i
				nogo = 1
				Exit
			;HOLDING A UNIT, then swap units
			Else
				u2 = Object unit unit_han(unit_held)
				temp_x = u\x:	temp_y = u\y
				u\x = u2\x:		u\y = u2\y
				u2\x = temp_x:	u2\y = temp_y
				unit_held = i
				Exit
			EndIf 
		EndIf 
	Next	

	;IF HOLDING UNIT OVER DEPLOY AREA THEN DROP ON SQUARE
	If phase = 1 And MouseX() < 768 And MouseY() > 576 And cursor_pic = 14 And nogo = 0
		x_pos = (MouseX() /16)*16:	y_pos = (MouseY()/16)*16
		u = Object unit unit_han(unit_held)
		u\x = x_pos:	 u\y = y_pos
		cursor_pic = 15
	Else If phase = 2 And MouseX() < 768 And MouseY() < 192 And cursor_pic = 14 And nogo = 0
		x_pos = (MouseX() /16)*16:	y_pos = (MouseY()/16)*16

		u = Object unit unit_han(unit_held)
		u\x = x_pos:	 u\y = y_pos
		cursor_pic = 15		
	EndIf 

EndIf 

If MouseHit(2) 
	For i = 1+bit To player_num_units(phase)+bit
		u = Object unit unit_han(i)
		If u\x > 768 Then nogo2 = 1
	Next 
	If nogo2 = 0 Then phase = phase + 1
	If phase = 3  	
		state = 3
		phase = 1
		unit_held = 1
	EndIf 
EndIf 
End Function
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function DRAW_UNITS()

ANIMATE_UNITS()

For u.unit = Each unit
	DrawImage units, u\x, u\y, u\frame
Next

If display_health = 1 					;numeric
	Color 255, 255, 255:	SetFont font2
	For u.unit = Each unit	
		Text u\x+2, u\y+4, u\hp
	Next
Else If display_health = 2				;health bar
	For u.unit = Each unit	
		Color 0,0,0:	 Rect u\x+12, u\y+1, 4, 15
		For n.new_man = Each new_man
			If n\name$ = u\name Then Exit
		Next
		num1# = n\hp:	num2# = u\hp
		px# = (13 / num1) * num2#
		For i = 1 To px
			Color 100+(i*10), 0+(i*15), 0
			Line u\x+13, u\y+15-i, u\x+14, u\y+15-i 
		Next
		
	Next
EndIf 

End Function 
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function HILIGHTER()


If  attack_box_s = 0
	attack_box_col = attack_box_col + 3
	If attack_box_col = 90 Then attack_box_s = 1
Else 
	attack_box_col = attack_box_col - 3
	If attack_box_col = 0 Then attack_box_s = 0
EndIf 

If attackstart = 1
	For i = 0 To 2
		Color 80+attack_box_col+(i*10)	, attack_box_col/2+(i*10)	, attack_box_col/2 +(i*10)		
		Rect attack_x_pos-1+i, attack_y_pos-1+i, 18-(i*2), 18-(i*2), 0
	Next
Else 
	u = Object unit unit_han(unit_held)
	For i = 0 To 8
		Color attack_box_col/2+(i*10)	, attack_box_col/2+(i*10)	, 80+attack_box_col +(i*10)	
		Rect u\x-1+i, u\y-1+i, 18-(i*2), 18-(i*2), 0
	Next
EndIf 

End Function
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function EFFECTS()
For f.effects = Each effects
	DrawImage effects, f\x, f\y, (f\id*11)+f\frame
	f\frame = f\frame + 1 
	If f\frame = 10 Then Delete f.effects
Next
End Function
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function UNIT_ACTIONS()

;If unit_action = 1	;MOVE
;	p.point = New point
;	p\x = u\x, p\y = u\y
;	Color 200, 0, 0
;	Rect p\x, u\x, 16, 16
;	
;	For p.point = Each point 
;		If u\y - 16 >= 0	;up
;			;p.point = New point
;			
;		EndIf
;	Next 	
;EndIf 

End Function
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function SIDEBAR()

;test stuff-:
;DrawImage tiles, 900, 740, cell(y_cell+1, x_cell+1)
u = Object unit unit_han(unit_held)

For n.new_man = Each new_man	;get units constructor version
	If n\name$ = u\name$ Then Exit
Next

;SELECTED UNIT IMAGE FRAME;-------------------------;
Color 20, 20, 20:		Rect 788, 20, 32, 32, 1
Color 100, 100, 100:	Rect 788, 20, 32, 32, 0
DrawImage units, 796, 28, u\frame
SetFont font2:	Text 790, 54, u\name$
;DRAW STAT BARS;------------------------------------;
For i = 0 To 2
	Color 0, 0, 0:	Rect 824+(i*12), 20, 8, 32, 1 
	
	If i = 0
		num1# = n\hp:	num2# = u\hp
		px = (30 / num1#) * num2#	
		If n\hp=0 Then px = 30	
	Else If i = 1
		num1# = n\mp:	num2# = u\mp
		px = (30 / num1#) * num2#	
		If n\mp=0 Then px = 30	
	Else
		num1# = n\ap:	num2# = u\ap
		px = (30 / num1#) * num2#	
		If n\ap=0 Then px = 30	
	EndIf 

	For y = 1 To px
		If i = 0
			Color 50+(y*5), 0+(y*7), 0 			
			Line 825, 51-y, 830, 51-y
		Else If i = 1
			Color 0, 0+(y*7), 50+(y*5)		
			Line 837, 51-y, 842, 51-y
		Else
			Color 0+(y*5), 50+(y*6), 0						
			Line 849, 51-y, 854, 51-y
		EndIf 	
	Next
Next
;STATS TEXT;-----------------------------------------;
Color 20, 20, 20:		Rect 904, 20, 100, 100, 1
Color 100, 100, 100:	Rect 904, 20, 100, 100, 0
SetFont font1:
Text 910, 24, "Move: "+u\move+" / "+n\move
Text 910, 38, "Health: "+u\hp+" / "+n\hp
Text 910, 52, "Magic: "+u\mp+" / "+n\mp
Text 910, 66, "Action points: "+u\ap+" / "+n\ap



For i = 0 To 3
	DrawImage buttons, 800+(i*40), 120, i
Next


End Function
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function END_PHASE()

For u.unit = Each unit
	;FIND UNITS CONSTRUCTOR
	For n.new_man = Each new_man
		If n\name$ = u\name$ Then Exit
	Next
	;REPLENISH MOVE AND ATTACK
	If u\hp > 0 
		u\move = n\move
		u\attacks = n\attacks
	Else
		u\move = 0
		u\attacks = 0
	EndIf 
	;IF IN CITY OR UNIT REGENERATES THEN HEAL HP
	
Next


;SWITCH TO NEXT PLAYERS GO-------------------:
If phase = 1 
	phase = 2
	unit_held = player_num_units(1)+1
Else 
	phase = 1
	turn = turn + 1		;increment game turn
	unit_held = 1
EndIf  

FlushKeys
Cls
Color 100,100,100 :SetFont font5
Text 300, 300, "PLAYER " +phase +"'S TURN"
Flip
WaitKey
SetFont font2
FlushKeys

End Function 
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function MOUSE_INPUT()
If MouseHit(1)
	;IF MOUSE OVER MAP

	If MouseX() < 768
		x_cell = MouseX() /16:	y_cell = MouseY()/16
		For u.unit = Each unit
		i=i+1
		If u\x = x_cell*16 And u\y = y_cell*16  
			If phase = 1  And i <=  player_num_units(1)
				unit_held = i
			Else If phase = 2 And i > player_num_units(1)
				unit_held = i
			EndIf 
		EndIf 
		action_state = 0

		Next
	EndIf 
EndIf 
End Function
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function KEY_INPUT()

If KeyHit(35) 		;H = view all units health
	display_health = display_health +1
	If display_health = 3 Then display_health = 0
;ACTION SELECT
Else If KeyHit(50)	;M = move unit
	action_state = 1
Else If KeyHit(46)	;C = brings up cellnumbers
	If cell_on = 0 
		cell_on = 1
	Else
		cell_on = 0
	EndIf 

;ATTACK KEY
Else If KeyHit(30);A
	If attackstart = 0
		u = Object unit unit_han(unit_held)
		If u\attacks > 0
			attackstart = 1		
			attack_x_pos = u\x
			attack_y_pos = u\y 	
		EndIf 
	Else If attackstart = 1	
		;CHECK IF HITTING A UNIT
		If CHECK_UNIT_COLLISION(attack_x_pos, attack_y_pos) = True
			For attacked.unit = Each unit
				If attacked\x = attack_x_pos And attacked\y = attack_y_pos Then Exit
			Next

				
			;DEFENSIVE TERRAIN
			GET_TERRAIN_TYPE((attack_y_pos/16)+1, (attack_x_pos/16)+1)

			damage = Rand(u\dam_min, u\dam_max)
			attacked\hp = attacked\hp - damage

			;CREATE EFFECTS ON ATTACKED
			f.effects = New effects 
			f\x = attacked\x:	f\y = attacked\y
			
			u\attacks = u\attacks - 1
			;HIDE UNIT IF DEAD			
			If attacked\hp < 1 Then attacked\x = -100
			
			attackstart = 0	
		;ELSE CANCEL THE ATTACK
		Else
			attackstart = 0
		EndIf 								
	EndIf
EndIf 



;ARROW KEYS
	
If attackstart = 0;NOT ATTACKING
	;MOVE KEYS
	If KeyHit(200);up
		;CHECK WITHIN LEVEL BOUNDARIES
		If u\y - 16 >= 0 	
			;CHECK FOR UNIT COLLISION
			If CHECK_UNIT_COLLISION(u\x, u\y-16) = False
				;CHECK MOVE COST
				GET_TERRAIN_TYPE((u\y)/16, (u\x/16)+1)
				If u\move - ter_move(ter_han) >=0
					u\y = u\y - 16
					u\move = u\move - ter_move(ter_han)
				EndIf 
			EndIf 
		EndIf 
	Else If KeyHit(208);down
		If u\y + 16 < 760
			If CHECK_UNIT_COLLISION(u\x, u\y+16) = False
				GET_TERRAIN_TYPE((u\y/16)+2, (u\x/16)+1)
				If u\move - ter_move(ter_han) >=0
					u\y = u\y + 16
					u\move = u\move - ter_move(ter_han)
				EndIf 
			EndIf 
		EndIf 
	Else If KeyHit(203);left
		If u\x - 16 >= 0 	
			If CHECK_UNIT_COLLISION(u\x, u\y+16) = False
				GET_TERRAIN_TYPE((u\y/16)+1, (u\x/16))
				If u\move - ter_move(ter_han) >=0
					u\x = u\x - 16
					u\move = u\move - ter_move(ter_han)
				EndIf 
			EndIf 
		EndIf 
	Else If KeyHit(205);right
		If u\x + 16 < 760
			If CHECK_UNIT_COLLISION(u\x, u\y+16) = False
				GET_TERRAIN_TYPE((u\y/16)+1, (u\x/16)+2)
				If u\move - ter_move(ter_han) >=0
					u\x = u\x + 16
					u\move = u\move - ter_move(ter_han)
				EndIf 
			EndIf 
		EndIf 
	EndIf
;ATTACKING
Else 
	If KeyHit(200);up
		If attack_range = 0	
			attack_y_pos = u\y -16
			attack_x_pos = u\x 
		EndIf 
	Else If KeyHit(208);down
		If attack_range = 0	
			attack_y_pos = u\y + 16
			attack_x_pos = u\x 
		EndIf 
	Else If KeyHit(203);left
		If attack_range = 0	
			attack_x_pos = u\x - 16	
			attack_y_pos = u\y 
		EndIf 
	Else If KeyHit(205);right
		If attack_range = 0	
			attack_x_pos = u\x + 16
			attack_y_pos = u\y
		EndIf 
	EndIf 
EndIf  

End Function
;--------------------------------------------;
Function CHECK_UNIT_COLLISION(x, y)
For u2.unit = Each unit 
	If u2\x = x And u2\y= y Then Return True
Next
End Function 
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function GET_TERRAIN_TYPE(x, y)

If cell(x,y)<1
	ter_han = 1			;Grass
Else If cell(x,y)<2
	ter_han =2			;Field
Else If cell(x,y)<10
	ter_han =3 			;Swamp
Else If cell(x,y)<17
	ter_han =4			;Lake
Else If cell(x,y)<20
	ter_han =5 			;Sea
Else If cell(x,y)<32
	ter_han =6			;River
Else If cell(x,y)<48
	ter_han =7			;Road
Else If cell(x,y)<49
	ter_han =8			;dense forest
Else If cell(x,y)<61
	ter_han =9			;forest edge
Else If cell(x,y)<64
	ter_han =10			;light woods
Else 
	ter_han =11			;hill
EndIf 

End Function 
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function CELL_NUMBERS()
If cell_on > 0
	Color 255, 0, 0
	For x = 0 To 768 Step 16
		Line x, 0, x, 768 
	Next
	For y = 0 To 768 Step 16
		Line 0, y, 768, y
	Next
	Color 0, 0, 255
	For y = 1 To 48
		For x = 1 To 48 
			Text ((x-1)*16)+2, ((y-1)*16)+2, cell(y, x) 	
		Next
	Next 
EndIf 
End Function
;------------------------------------------------------------------------------------------------------;
;******************************************************************************************************;
;------------------------------------------------------------------------------------------------------;
Function UNIT_CONSTRUCTOR()

;INFANTRY---------------------------;
n.new_man = New new_man
n\cost = 20
n\name$ = "Infantry":	n\move = 8
n\hp = 10 	n\mp = 0:	n\ap = 0
n\dam_min = 2:	n\dam_max = 8
n\frame = 34:	n\frames = 2
n\attacks = 1
constructor_han(1) = Handle(n)
;special diagonal attack
;SCOUT------------------------------;  
n.new_man = New new_man	
n\cost = 30:	
n\name$ = "Scout":	n\move = 12		
n\hp = 8:	n\mp = 0:	n\ap = 1	
n\dam_min = 1:	dam_max = 5
n\frame = 20:	n\frames = 2
n\attacks = 1
constructor_han(2) = Handle(n)
;special concealment, costs 1 ap
;special forestwalk 
;ARCHER-----------------------------;
n.new_man = New new_man
n\cost = 30
n\name$ = "Archer":	n\move = 8
n\hp = 8:	n\mp = 0:	n\ap = 0
n\dam_min = 1:	n\dam_max = 6
n\frame = 30:	n\frames = 2
n\attacks = 1
constructor_han(3) = Handle(n)
;attack range 5 
;no special
;KNIGHT-----------------------------;
n.new_man = New new_man
n\cost = 50
n\name$ = "Knight":	n\move = 8
n\hp = 20:	n\mp = 0:	n\ap = 2
n\dam_min = 4:	n\dam_max = 16
n\frame = 22:	n\frames = 2
n\attacks = 1
constructor_han(4) = Handle(n)
;charge attack
;TEMPLAR----------------------------;
n.new_man = New new_man
n\cost = 50
n\name$ = "Templar":	n\move = 8
n\hp = 20:	n\mp = 0:	n\ap = 2
n\dam_min = 2:	n\dam_max = 12
n\frame = 26:	n\frames = 2
n\attacks = 1
constructor_han(5) = Handle(n)
;special: double damage to undead, half damage from undead
;HERO-------------------------------;
n.new_man = New new_man
n\cost = 120
n\name$ = "Hero":	n\move = 10
n\hp = 35:	n\mp = 0:	n\ap = 5
n\dam_min = 8:	n\dam_max = 24
n\frame = 44:	n\frames = 2
n\attacks = 2
constructor_han(6) = Handle(n)
;special: boost friendly units strength in 3 square radius 
;DRUID------------------------------;
n.new_man = New new_man
n\cost = 50
n\name$ = "Druid":	n\move = 8
n\hp = 10:	n\mp = 4:	n\ap = 0
n\dam_min = 2:	n\dam_max = 6
n\frame = 24:	n\frames = 2
n\attacks = 1
constructor_han(7) = Handle(n)
;special forestwalk
;special summon spider
;special summon rat
;PRIEST-----------------------------;
n.new_man = New new_man
n\cost = 50
n\name$ = "Priest":	n\move = 8
n\hp = 6:	n\mp = 4:	n\ap = 0
n\dam_min = 1:	n\dam_max = 40
n\frame = 16:	n\frames = 2
n\attacks = 1
constructor_han(8) = Handle(n)
;special spell, heal
;special spell, repel undead
;special spell, paralyze
;MAGE-------------------------------;
n.new_man = New new_man
n\cost = 50
n\name$ = "Mage":	n\move = 8
n\hp = 6:	n\mp = 4:	n\ap = 0
n\dam_min = 1:	n\dam_max = 4
n\frame = 18:	n\frames = 2
n\attacks = 1
constructor_han(9) = Handle(n)
;special spell, haste
;special spell, flight
;special spell, lightning bolt 
;DRAGON-----------------------------;
n.new_man = New new_man
n\cost = 200
n\name$ = "Dragon":	n\move = 8
n\hp = 50:	n\mp = 0:	n\ap = 3
n\dam_min = 1:	n\dam_max = 40
n\frame = 56:	n\frames = 4
n\attacks = 3
constructor_han(10) = Handle(n)
;special flying
;special firebreath, cost 1 ap


;SKELETON---------------------------;
n.new_man = New new_man
n\cost = 10
n\name$ = "Skeleton":	n\move = 6
n\hp = 5:	n\mp = 0:	n\ap = 0
n\dam_min = 1:	n\dam_max = 6
n\frame = 80:	n\frames = 4
n\attacks = 1
constructor_han(11) = Handle(n)
;no special
;TROG-------------------------------;
n.new_man = New new_man
n\cost = 20
n\name$ = "Trog":	n\move = 8
n\hp = 10:	n\mp = 0:	n\ap = 0
n\dam_min = 4:	n\dam_max = 8
n\frame = 64:	n\frames = 4
n\attacks = 1
constructor_han(12) = Handle(n)
;special regenerates
;OGRE-------------------------------;
n.new_man = New new_man
n\cost = 40
n\name$ = "Ogre":	n\move = 6
n\hp = 30:	n\mp = 0:	n\ap = 1
n\dam_min = 2:	n\dam_max = 12
n\frame = 72:	n\frames = 4
n\attacks = 1
constructor_han(13) = Handle(n)
;special berserk attack, damages all adjacent units, costs 1 ap
;MEGATROG---------------------------;
n.new_man = New new_man
n\cost = 50
n\name$ = "Megatrog":	n\move = 8
n\hp = 20:	n\mp = 0:	n\ap = 2

n\dam_min = 4:	n\dam_max = 16
n\frame = 68:	n\frames = 4
n\attacks = 1
constructor_han(14) = Handle(n)
;special regenerates
;GARGOYLE--------------------------;
n.new_man = New new_man
n\cost = 50
n\name$ = "Gargoyle":	n\move = 8
n\hp = 16:	n\mp = 0:	n\ap = 0
n\dam_min = 2:	n\dam_max = 10
n\frame = 76:	n\frames = 4
n\attacks = 1
constructor_han(15) = Handle(n)
;special attack range 5
;WRAITH----------------------------;
n.new_man = New new_man
n\cost = 50
n\name$ = "Wraith":	n\move = 12
n\hp = 20:	n\mp = 0:	n\ap = 2
n\dam_min = 1:	n\dam_max = 10
n\frame = 92:	n\frames = 4
n\attacks = 1
constructor_han(16) = Handle(n)
;special etheral (flying + move through walls)
;special half damage from non magic 
;special conceal, 1 ap  
;SKELETON MAGE---------------------;
n.new_man = New new_man
n\cost = 30
n\name$ = "Sk Mage":	n\move = 6
n\hp = 5:	n\mp = 4:	n\ap = 0
n\dam_min = 1:	n\dam_max = 4
n\frame = 84:	n\frames = 4
n\attacks = 1
constructor_han(17) = Handle(n)
;special spell, magic missile
;WARLOCK---------------------------;
n.new_man = New new_man
n\cost = 50
n\name$ = "Warlock":	n\move = 8
n\hp = 6:	n\mp = 4:	n\ap = 0
n\dam_min = 1:	n\dam_max = 4
n\frame = 52:	n\frames = 4
n\attacks = 1
constructor_han(18) = Handle(n)
;special spell, Firewall
;special spell, Fireball
;special spell, Slow

;VAMPIRE---------------------------;
n.new_man = New new_man
n\cost = 120
n\name$ = "Vampire":	n\move = 10
n\hp = 35:	n\mp = 5:	n\ap = 0
n\dam_min = 1:	n\dam_max = 20
n\frame = 48:	n\frames = 4
n\attacks = 2
constructor_han(19) = Handle(n)
;special spell, drain life
;special spell, teleport
;special spell, summon skeleton
;special becomes bat when dies
;DEAMON----------------------------;
n.new_man = New new_man
n\cost = 200
n\name$ = "Deamon":	n\move = 8
n\hp = 50:	n\mp = 0:	n\ap = 3
n\dam_min = 1:	n\dam_max = 40
n\frame = 60:	n\frames = 4
n\attacks = 3
constructor_han(20) = Handle(n)
;special flying
;Cause fear, 1 ap

End Function



 